﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ELTE.Basics.University
{
    class Course // egyetemi kurzus típusa
    {
        private String _Name; // kurzus neve
        private List<Student> _Students; // kurzus hallgatói
        private Teacher _Teacher; // kurzus oktatója

        public String Name { get { return _Name; } }
        public Teacher Teacher { get { return _Teacher; } }
        public Int32 StudentCount { get { return _Students.Count; } }

        public Course(Teacher teacher, String name)
        {
            _Name = name;
            _Teacher = teacher;
            _Students = new List<Student>();
        }

        public Boolean AddStudent(Student student) // hallgató felvétele
        {
            if (!_Students.Contains(student)) // ha még nincs benne a névsorban
            {
                _Students.Add(student); // vegyük fel
                return true; // jelezzük, hogy sikeres volt a felvétel
            }
            else
                return false;
        }

        public List<Student> GetStudentsList(Teacher teacher) // hallgatók listájának lekérdezése
        {
            if (teacher == _Teacher) // ha a kurzus oktatója
                return _Students; // akkor lekérdezheti a hallgatók listáját, és módosíthatja is azt
            else
                return new List<Student>(); // különben egy üres listát kap
        }

        public List<Student> GetStudentsList(Student student)
        {
            if (_Students.Contains(student)) // ha hallgatója a kurzusnak
                return new List<Student>(_Students); // akkor megkapja a lista másolatát, így nem tudja módosítani az eredetit
            else
                return new List<Student>(); // különben egy üres listát kap
        }
    }
}
